﻿using System;
using System.Collections.Generic;
using System.Diagnostics;
using System.IO;
using System.Text;

namespace HeuristicLab.PluginInfrastructure {
  public class DockerRunner : IRunner {

    private Process process;
    public void Start(string basePath, string[] args) {
      string arguments =
        $"run -i --rm --mount type=bind,source=/,target=/app/ dockerrunner -- " +
        $"--basePath /app{basePath} -- ";
      foreach (string s in args) arguments += s + " ";
      process = new Process {
        StartInfo = new ProcessStartInfo {
          FileName = "docker",
          Arguments = arguments,
          UseShellExecute = false,
          RedirectStandardOutput = true,
          RedirectStandardInput = true,
          RedirectStandardError = true,
          CreateNoWindow = false
        }
      };
      process.Start();
      process.BeginOutputReadLine();
      process.BeginErrorReadLine();
      process.OutputDataReceived += (s, e) => Console.WriteLine(e.Data);
      process.ErrorDataReceived += (s, e) => Console.WriteLine(e.Data);
    }

    public void Stop() {
      process.WaitForExit();
      process.Close();
    }
  }
}
