﻿using System;
using System.Collections.Generic;
using System.Text;

namespace HeuristicLab.PluginInfrastructure {
  /// <summary>
  /// Classes from type IActivator gets automatically searched and activated with the method "Activate".
  /// </summary>
  public interface IActivator {
    /// <summary>
    /// The entry point of an IActivator.
    /// </summary>
    /// <param name="context"></param>
    /// <param name="args"></param>
    void Activate(IActivatorContext context, string[] args);
    void Stop(IActivatorContext context);
  }
}
