﻿using System;
using System.Collections.Generic;
using System.Text;
using HeuristicLab.PluginInfrastructure;

namespace HeuristicLab.PluginInfrastructure {
  /// <summary>
  /// Interface for a ActivatorContext implementation.
  /// </summary>
  public interface IActivatorContext {
    /// <summary>
    /// Returns all plugins found by a PluginLoader.
    /// </summary>
    IList<IPlugin> Plugins { get; }

    /// <summary>
    /// Returns all applications found by a PluginLoader.
    /// </summary>
    IList<IApplication> Applications { get; }

  }
}
