﻿using System;
using System.Collections.Generic;
using System.Reflection;
using System.Text;

namespace HeuristicLab.PluginInfrastructure {
  public interface IAssemblyLoader {
    string BasePath { get; set; }

    /// <summary>
    /// Returns all loaded assemblies.
    /// </summary>
    IEnumerable<Assembly> Assemblies { get; }
    /// <summary>
    /// Returns all types.
    /// </summary>
    IEnumerable<Type> Types { get; }

    /// <summary>
    /// Returns all assemblies included in BasePath. 
    /// </summary>
    /// <returns></returns>
    IEnumerable<Assembly> GetReflectionOnlyAssemblies();

    /// <summary>
    /// Loads all assembliesm which are given by the assemblyName argument, into the current context. 
    /// </summary>
    /// <param name="assemblyNames"></param>
    /// <returns>All loaded assemblies.</returns>
    IEnumerable<Assembly> LoadAssemblies(IEnumerable<AssemblyName> assemblyNames);

  }
}
