﻿using System;
using System.Collections.Generic;
using System.Text;

namespace HeuristicLab.PluginInfrastructure {

  /// <summary>
  /// Interface for all runner implementations.
  /// </summary>
  public interface IRunner {
    /// <summary>
    /// Method to start the runner which scans all assemblies in the given basePath argument. 
    /// Additionally, arguments can be specified, which are forwarded to all activators.
    /// </summary>
    /// <param name="basePath"></param>
    /// <param name="args"></param>
    void Start(string basePath, string[] args);

    void Stop();
  }
}
